-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------

function Stratosphere:StartActivity()
   	print("START! -- Stratosphere:StartActivity()!");
	
	self.ShipSpawn = SceneMan.Scene:GetArea("ShipSpawn");
	self.KamikadzeLand = SceneMan.Scene:GetArea("KamikadzeLand");
	self.DataUploadZone = SceneMan.Scene:GetArea("DataUpload");
	self.DummyAssaultTrigger = SceneMan.Scene:GetArea("DummyAssaultTrigger");
	self.ReinforcementsLZ = SceneMan.Scene:GetArea("ReinforcementsLZ");
	self.AuxilaryTerminal = SceneMan.Scene:GetArea("AuxilaryTerminal");
	self.HealingZone = SceneMan.Scene:GetArea("HealingZone");

	self.Level1LeftLZ = SceneMan.Scene:GetArea("Level1LeftLZ");
	self.Level2LeftLZ = SceneMan.Scene:GetArea("Level2LeftLZ");
	self.Level1RightLZ = SceneMan.Scene:GetArea("Level1RightLZ");
	self.Level2RightLZ = SceneMan.Scene:GetArea("Level2RightLZ");

	self.CommanderLZLeft = SceneMan.Scene:GetArea("CommanderLZLeft");
	self.CommanderLZUp = SceneMan.Scene:GetArea("CommanderLZUp");
	self.CommanderLZLeftUp = SceneMan.Scene:GetArea("CommanderLZLeftUp");

	self.LightWList = { "Blaster", "Rail Pistol" , "Sniper Rifle"};
	self.HeavyWList = { "Repeater", "Destroyer Cannon", "Nailer Cannon" };
	self.SuperHeavyWList = { "Grenade Launcher", "Repeater" , "Annihiliator"};

	self.braindead = {};
	self.AssignedBrains = {};
	self.CPUBrain1 = nil;
	self.CPUBrain2 = nil;
	self.MOIDLimit = 220;
    
    self.GenericTimer = Timer();
    self.GenericTimer:Reset();

   	self.SpawnTimer = Timer();
	self.SpawnTimer:Reset();
	
    self.FightPhase = { NOFIGHT = 0, UPLOAD = 1 , HOLDPOSITION = 2 , COMMANDERHUNT = 3 , CHIPACTIVATION = 4};
    self.CurrentFightPhase = self.FightPhase.NOFIGHT;
    -- self.CurrentFightPhase = self.FightPhase.COMMANDERHUNT; -- Debug only
    self.DummyDropshipsEnabled = false;
    -- self.DummyDropshipsEnabled = true; -- Debug only 

	-- Reinforcements specific variables
	self.ReinforcementsSpawnTimer = Timer();
	self.ReinforcementsSpawnTimer:Reset();
	self.ReinforcementsEnabled = false;
	self.ReinforcementsSpawnInterval = 20000;
	self.ReinforcementRobotPending = false;

	-- How much you need to do to gain a robot
	self.FragsForRobot = 25; -- How many frags needed to gain a robot reinforcement
	self.FragsForRobotIncrement = 25; -- How many frags added to gain next robot
	
	-- Kamikadze launch specific variables 
	self.KamikadzePhase = { PREPARE = 0, LAUNCH = 1 };
	self.CurrentKamikadzePhase = self.KamikadzePhase.PREPARE;
	self.KamikadzeFromLeft = false;
	self.KamikadzeSpawnTimer = Timer();
	self.KamikadzeSpawnTimer:Reset();
	self.KamikadzePhaseTimer = Timer();
	self.KamikadzePhaseTimer:Reset();
	self.KamikadzeLaunched = false;
	self.KamikadzeTarget = Vector(0 , 0);
	self.KamikadzeShip = nil;
	self.KamikadzeSpawnInterval = 14000;
	self.KamikadzeCoverDelay = 7000; -- Delay between Cover warning and actual kamikadze launch
	
	-- Healing parameters
	self.HealTimer = Timer();
	self.HealTimer:Reset();
	
	-- Generic timing and money parameters
	self.DropshipSpawnInterval = 10000;
	-- No money and alive reinforcements availabe for player according to the plot
	self.PlayerGold = 0; -- Player starting credits

	-- Phase "Upload" timings and variables
	self.UploadSpawnInterval = 8000;
	self.UploadInterval = 10000; -- Time needed to upload one chunk of data
	self.UploadedChunks = 0;
	self.MainScreen = nil;
	self.SmallScreens = {};
	
	-- Phase "Hold position variables"
	self.HoldPositionSpawnInterval = 8000;
	self.MessageDisplayTime = 9000;
	self.NextMessageInterval = 10000;
	self.HoldMessage1Shown = false;
	self.HoldMessage2Shown = false;
	self.HoldMessage3Shown = false;
	self.HoldMessage4Shown = false;
	self.HoldMessage5Shown = false;
	self.HoldMessage6Shown = false;
	
	-- Phase "Commander hunt" variables
	self.CommanderHuntSpawnInterval = 12000;
	self.DummyCommander = nil;
	self.Chip1Collected = false;
	self.Chip2Collected = false;
	self.Chip3Collected = false;

	-- Phase "Chip activation" variables
	self.ChipActivationSpawnInterval = 8000;
	self.KeysActivated = false;
	self.CrackInterval = 120000;
	self.CrackMessage1Shown = false;
	self.CrackMessage2Shown = false;
	self.CrackMessage3Shown = false;
	self.CrackMessage4Shown = false;
	self.AuxScreen = CreateAEmitter("Dummy Logo Screen");
	self.AuxScreen.Pos = Vector(1680, 1670);
	self.MissionComplete = false;

	-- Debug only. Put all three chips near aux terminal
	--[[ local chip = CreateHeldDevice("Dummy Chip 1","Stratosphere.rte");
	chip.Pos = Vector(1670 , 1660)
	MovableMan:AddItem(chip);

	chip = CreateHeldDevice("Dummy Chip 2","Stratosphere.rte");
	chip.Pos = Vector(1680 , 1660)
	MovableMan:AddItem(chip);

	chip = CreateHeldDevice("Dummy Chip 3","Stratosphere.rte");
	chip.Pos = Vector(1690 , 1660)
	MovableMan:AddItem(chip);]]


   	-- Set up teams
   	-- Team 2 is always CPU
   	self.CPUTeam = Activity.TEAM_2;
    
   	-- Set up players
    for player = 0, self.PlayerCount - 1 do
        -- Check if we already have a brain assigned
        if not self:GetPlayerBrain(player) then
			self.braindead[player] = false;
			local brain = CreateAHuman("Brain Robot");
			brain.Pos = Vector(2900 + player * 30 , 1690);
			-- brain.Pos = Vector(1668 + player * 30 , 2112); -- Debug position in bunker
			-- brain.Pos = Vector(1650 + player * 30 , 1660); -- Debug position near aux terminal
			brain:AddInventoryItem(CreateHDFirearm("Auto Pistol","Coalition.rte"));
			-- brain:AddInventoryItem(CreateHDFirearm("Compact Assault Rifle","Coalition.rte"));
			brain.AIMode = Actor.AIMODE_SENTRY;
			brain.Health = 15;
			self.AssignedBrains[player] = brain;
            -- Let the spawn into the world, passing ownership
            MovableMan:AddActor(brain);
            -- Set the found brain to be the selected actor at start
            self:SetPlayerBrain(brain, player);
            SceneMan:SetScroll(self:GetPlayerBrain(player).Pos, player);
            self:SetLandingZone(self:GetPlayerBrain(player).Pos, player);
            -- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
            self:SetObservationTarget(self:GetPlayerBrain(player).Pos, player);
        end
    end

	--[[local ship = CreateACDropship("Drop Ship" , "Dummy.rte");
	ship.Pos = Vector(2860 , 1912);
	ship.AIMode = Actor.AIMODE_DELIVER;
	ship.Team = -1;
	MovableMan:AddActor(ship);]]

	-- Set up screens
	self.MainScreen = CreateAEmitter("Stratosphere Big Screen");
	self.MainScreen.Pos = Vector(1800, 2024);

	-- Upper screen row
	self.SmallScreens[0] = CreateAEmitter("Stratosphere Small Screen 1");
	self.SmallScreens[0].Pos = Vector(1656, 1914);

	self.SmallScreens[1] = CreateAEmitter("Stratosphere Small Screen 2");
	self.SmallScreens[1].Pos = Vector(1656 + 72, 1914);

	self.SmallScreens[2] = CreateAEmitter("Stratosphere Small Screen 3");
	self.SmallScreens[2].Pos = Vector(1656 + 72 * 2, 1914);

	self.SmallScreens[3] = CreateAEmitter("Stratosphere Small Screen 4");
	self.SmallScreens[3].Pos = Vector(1656 + 72 * 3, 1914);

	self.SmallScreens[4] = CreateAEmitter("Stratosphere Small Screen 5");
	self.SmallScreens[4].Pos = Vector(1656 + 72 * 4, 1914);
	
	-- Left screen pane
	self.SmallScreens[5] = CreateAEmitter("Stratosphere Small Screen 6");
	self.SmallScreens[5].Pos = Vector(1584, 1992);

	self.SmallScreens[6] = CreateAEmitter("Stratosphere Small Screen 7");
	self.SmallScreens[6].Pos = Vector(1584 + 72, 1992);
	
	self.SmallScreens[7] = CreateAEmitter("Stratosphere Small Screen 8");
	self.SmallScreens[7].Pos = Vector(1584 , 1992 + 72);

	self.SmallScreens[8] = CreateAEmitter("Stratosphere Small Screen 9");
	self.SmallScreens[8].Pos = Vector(1584 + 72, 1992 + 72);
	
	-- Right screen pane
	self.SmallScreens[9] = CreateAEmitter("Stratosphere Small Screen 10");
	self.SmallScreens[9].Pos = Vector(1944, 1992);

	self.SmallScreens[10] = CreateAEmitter("Stratosphere Small Screen 11");
	self.SmallScreens[10].Pos = Vector(1944 + 72, 1992);
	
	self.SmallScreens[11] = CreateAEmitter("Stratosphere Small Screen 12");
	self.SmallScreens[11].Pos = Vector(1944 , 1992 + 72);

	self.SmallScreens[12] = CreateAEmitter("Stratosphere Small Screen 13");
	self.SmallScreens[12].Pos = Vector(1944 + 72, 1992 + 72);
	

    -- Set up AI modes for the Actors that have been added to the scene by the scene definition
    for actor in MovableMan.AddedActors do
		actor.AIMode = Actor.AIMODE_SENTRY;
    end

    -- Set the team's funds.
    self:SetTeamFunds(self.PlayerGold,Activity.TEAM_1);

    --------------------------
    -- Set up tutorial
    
    self.SpawnTimer:Reset();
    
end

-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------

function Stratosphere:PauseActivity(pause)
    print("PAUSE! -- DummyAssault:PauseActivity()!");
end

-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------

function Stratosphere:EndActivity()
    print("END! -- DummyAssault:EndActivity()!");
end

-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------

function Stratosphere:UpdateActivity()
   	-- Clear all objective markers, they get re-added each frame
   	self:ClearObjectivePoints();

	--
	-- Generic processing
	--
	-- Brain selection and gameover conditions check
	if not (self.ActivityState == Activity.OVER) then
		-- Iterate through all human players
		for player = 0, self.PlayerCount - 1 do
			-- The current player's team
			local team = self:GetTeamOfPlayer(player);
	
			-- Make sure the game is not already ending
			-- Check if any player's brain is dead
			local brain = self:GetPlayerBrain(player);
			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				self:SetPlayerBrain(nil, player);
				-- Try to find a new unasigned brain this player can use instead, or if his old brain entered a craft
				local newBrain = MovableMan:GetUnassignedBrain(team);
				-- Found new brain actor, assign it and keep on truckin'
				if newBrain and self.braindead[player] == false then
					self:SetPlayerBrain(newBrain, player);
					self:SwitchToActor(newBrain, player, team);

					self.VictimBrain = newBrain;
				else
					FrameMan:SetScreenText("Your brain has been lost!", player, 333, -1, false);
					self.braindead[player] = true;
					
					-- Now see if all brains of self player's team are dead, and if so, end the game
					if not MovableMan:GetClosestBrainActor(team) then
						self.WinnerTeam = self:OtherTeam(team);
						ActivityMan:EndActivity();
					end
				end
			else
				-- Update the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
				self:SetObservationTarget(brain.Pos, player)
			end -- 
		end --for
	-- Game over, show the appropriate messages until a certain time
	elseif not self.GameOverTimer:IsPastSimMS(self.GameOverPeriod) then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);
			-- TODO: make more appropriate messages here for run out of funds endings
			if team == self.WinnerTeam then
				FrameMan:SetScreenText("Congratulations, dummies defeated!", player, 0, -1, false);
			else
				FrameMan:SetScreenText("Your brain has been lost!", player, 0, -1, false);
			end
		end
	end
	
	
	-- Check if we deserved a robot for frags
	if self:GetTeamDeathCount(Activity.TEAM_2) >= self.FragsForRobot then
		print("Robot awarded");
		self.FragsForRobot = self.FragsForRobot + self.FragsForRobotIncrement;
		self.ReinforcementRobotPending = true;
	end
	
	-- Spawn reinforcements
	if self.ReinforcementsSpawnTimer:IsPastSimMS(self.ReinforcementsSpawnInterval) and MovableMan:GetMOIDCount() <= self.MOIDLimit and self.ReinforcementsEnabled then
		print("Spawn reinforcement crate");				
		local ship = CreateACRocket("Drop Crate","Dummy.rte");
		ship.Team = -1;

		-- Check if player deserved a robot as a reinforcement
		if self.ReinforcementRobotPending then
			local robot = CreateAHuman("Robot 1")
			robot.Team = Activity.TEAM_1;
			robot.AIMode = Actor.AIMODE_SENTRY;
			robot:AddInventoryItem(CreateHDFirearm("Assault Rifle MK2","Stratosphere.rte"));
			ship:AddInventoryItem(robot);
			self.ReinforcementRobotPending = false;
			ship.Team = Activity.TEAM_1;
		else
			local rand = math.random();
			
			if rand < 0.05 then
				ship:AddInventoryItem(CreateHDFirearm("Gatling Gun MK2","Stratosphere.rte"));
			elseif rand < 0.15 then
				ship:AddInventoryItem(CreateHDFirearm("Heavy Sniper Rifle MK2","Stratosphere.rte"));
			elseif rand < 0.45 then
				ship:AddInventoryItem(CreateHDFirearm("Auto Shotgun MK2","Stratosphere.rte"));
			else 
				ship:AddInventoryItem(CreateHDFirearm("Assault Rifle MK2","Stratosphere.rte"));
			end
		end
		
		ship.Pos = Vector(self.ReinforcementsLZ:GetRandomPoint().X, 0);
		MovableMan:AddActor(ship);
		self.ReinforcementsSpawnTimer:Reset();
	end
	
	-- Spawn ships
	if self.SpawnTimer:IsPastSimMS(self.DropshipSpawnInterval) and MovableMan:GetMOIDCount() <= self.MOIDLimit and self.DummyDropshipsEnabled then
		-- Add dummies and ship
		print("Spawn ship");				
		local ship = CreateACDropShip("Drop Ship","Dummy.rte");
		for i = 0 , 1 do
			print("Spawn dummies");				
			local actor = nil;
			
			if self.CurrentFightPhase == self.FightPhase.NOFIGHT or self.CurrentFightPhase == self.FightPhase.UPLOAD then
				if math.random() < 0.95 then
					actor = CreateAHuman("Dummy");

					actor:AddInventoryItem(CreateHDFirearm(self.LightWList[math.random(#self.LightWList)],"Dummy.rte"));
					if math.random() < 0.3 then
						actor:AddInventoryItem(CreateHDFirearm("Nailgun","Dummy.rte"));
					else
						actor:AddInventoryItem(CreateHDFirearm("Turbo Digger","Dummy.rte"));
					end
					
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
				else
					actor = CreateACrab("Dreadnought");
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
				end
			
			elseif self.CurrentFightPhase == self.FightPhase.HOLDPOSITION then
				if math.random() < 0.90 then
					actor = CreateAHuman("Dummy");

					if math.random() < 0.08 then
						actor:AddInventoryItem(CreateHDFirearm("Blaster MK2","Stratosphere.rte"));
					else
						actor:AddInventoryItem(CreateHDFirearm(self.LightWList[math.random(#self.LightWList)],"Dummy.rte"));
					end
					
					if math.random() < 0.3 then
						actor:AddInventoryItem(CreateHDFirearm("Nailgun","Dummy.rte"));
					else
						actor:AddInventoryItem(CreateHDFirearm("Turbo Digger","Dummy.rte"));
					end
					
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
				else
					actor = CreateACrab("Dreadnought");
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
				end

			elseif self.CurrentFightPhase == self.FightPhase.COMMANDERHUNT then
				if math.random() < 0.80 then
					actor = CreateAHuman("Dummy");

					if math.random() < 0.30 then
						actor:AddInventoryItem(CreateHDFirearm("Blaster MK2","Stratosphere.rte"));
					else
						actor:AddInventoryItem(CreateHDFirearm(self.LightWList[math.random(#self.LightWList)],"Dummy.rte"));
					end
					
					if math.random() < 0.3 then
						actor:AddInventoryItem(CreateHDFirearm("Nailgun","Dummy.rte"));
					else
						actor:AddInventoryItem(CreateHDFirearm("Turbo Digger","Dummy.rte"));
					end
					
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
				else
					actor = CreateACrab("Dreadnought");
					actor.AIMode = Actor.AIMODE_BRAINHUNT;
				end
			elseif self.CurrentFightPhase == self.FightPhase.CHIPACTIVATION then
					actor = CreateAHuman("Dummy");

					if math.random() < 0.5 then
						actor:AddInventoryItem(CreateHDFirearm("Blaster MK2","Stratosphere.rte"));
					else
						actor:AddInventoryItem(CreateHDFirearm(self.SuperHeavyWList[math.random(#self.SuperHeavyWList)],"Dummy.rte"));
					end
					actor:AddInventoryItem(CreateHDFirearm("Turbo Digger","Dummy.rte"));

					actor.AIMode = Actor.AIMODE_BRAINHUNT;
			end

			actor.Team = Activity.TEAM_2;
			ship:AddInventoryItem(actor);
		end

		-- Select enemy LZ according to current fight stage
		if self.CurrentFightPhase == self.FightPhase.NOFIGHT or self.CurrentFightPhase == self.FightPhase.UPLOAD then
			if math.random() < 0.4 then
				ship.Pos = Vector(self.Level1LeftLZ:GetRandomPoint().X, 0);
			else
				ship.Pos = Vector(self.Level1RightLZ:GetRandomPoint().X, 0);
			end
		else
		-- if self.CurrentFightPhase == self.FightPhase.HOLDPOSITION or self.CurrentFightPhase == self.FightPhase.COMMANDERHUNT or self.CurrentFightPhase == self.FightPhase.CHIPACTIVATION then
			local rand = math.random();
			
			if rand < 0.25 then
				ship.Pos = Vector(self.Level1LeftLZ:GetRandomPoint().X, 0);
			elseif rand < 0.5 then
				ship.Pos = Vector(self.Level1RightLZ:GetRandomPoint().X, 0);
			elseif rand < 0.75 then
				ship.Pos = Vector(self.Level2LeftLZ:GetRandomPoint().X, 0);
			else
				ship.Pos = Vector(self.Level2RightLZ:GetRandomPoint().X, 0);
			end
		end
		
		ship.Team = Activity.TEAM_2;
		ship:SetControllerMode(Controller.CIM_AI, -1);
		MovableMan:AddActor(ship);
		self.SpawnTimer:Reset();
		print("Ship spawn complete");				
	end

	-- Decide whether we need to launch kamikadze
	if self.KamikadzeSpawnTimer:IsPastSimMS(self.KamikadzeSpawnInterval) and MovableMan:GetMOIDCount() <= self.MOIDLimit and self.KamikadzeLaunched == false and self.DummyDropshipsEnabled then
		for actor in MovableMan.Actors do
			if actor.Team == Activity.TEAM_1 and self.KamikadzeLand:IsInside(actor.Pos) and math.random() > 0.8 then
				self.KamikadzeLaunched = true;
				self.KamikadzeTarget = Vector(actor.Pos.X , actor.Pos.Y);
				self.KamikadzePhaseTimer:Reset();
				self.CurrentKamikadzePhase = self.KamikadzePhase.PREPARE;

				if self.KamikadzeTarget.X < 1800 then
					self.KamikadzeFromLeft = true;
				else
					self.KamikadzeFromLeft = false;
				end

				print("Kamikadze Triggered");
				break;
			end
		end
		self.KamikadzeSpawnTimer:Reset();
	end
	
	-- Do kamikadze phases
	if self.KamikadzeLaunched then
		if self.KamikadzeFromLeft then
			self:AddObjectivePoint("COVER!!!", self.KamikadzeTarget + Vector(100 , -10), Activity.TEAM_1, GameActivity.ARROWRIGHT);		
		else
			self:AddObjectivePoint("COVER!!!", self.KamikadzeTarget + Vector(-100 , -10), Activity.TEAM_1, GameActivity.ARROWLEFT);		
		end

		-- Spawn kamikadze and launch him
		if self.KamikadzePhaseTimer:IsPastSimMS(self.KamikadzeCoverDelay) and self.CurrentKamikadzePhase == self.KamikadzePhase.PREPARE then
			self.KamikadzeShip = CreateACRocket("Rocklet","Dummy.rte");
			for i = 0 , 4 do
				self.KamikadzeShip:AddInventoryItem(CreateTDExplosive("Standard Bomb","Coalition.rte"));
			end
	
			self.KamikadzeShip.Team = Activity.TEAM_2;
			self.KamikadzeShip:SetControllerMode(Controller.CIM_AI, -1);


			if self.KamikadzeFromLeft then
				self.KamikadzeShip.Pos = Vector(0, self.KamikadzeTarget.Y - (self.KamikadzeTarget.X / 12));
				self.KamikadzeShip.RotAngle = math.rad(270);
				self.KamikadzeShip.Vel = Vector(80 , 0);
			else
				self.KamikadzeShip.Pos = Vector(3000, self.KamikadzeTarget.Y - ((3000 - self.KamikadzeTarget.X) / 12));
				self.KamikadzeShip.RotAngle = math.rad(90);
				self.KamikadzeShip.Vel = Vector(-80 , 0);
			end
			
			MovableMan:AddActor(self.KamikadzeShip);
			self.CurrentKamikadzePhase = self.KamikadzePhase.LAUNCH;
		end
		
		-- Rocklet is dead, kamikadze cycle is over
		if self.KamikadzeShip == nil and self.CurrentKamikadzePhase == self.KamikadzePhase.LAUNCH then
			self.KamikadzeLaunched = false;
			self.KamikadzeTarget = nil;
			self.KamikadzeSpawnTimer:Reset();
		end

		-- Rocklet timed out, kamikadze cycle is over
		if self.KamikadzePhaseTimer:IsPastSimMS(8000) then
			if not self.KamikadzeShip == nil then
				self.KamikadzeShip:GibThis();
			end
			self.KamikadzeTarget = nil;
			self.KamikadzeLaunched = false;
			self.KamikadzeSpawnTimer:Reset();
		end
	end

	-- Healing pod
	if self.HealTimer:IsPastSimMS(1000) then
        for actor in MovableMan.Actors do
			if self.HealingZone:IsInside(actor.Pos)	then
				if actor.Health < 100 then
					if actor.Health < 70 then
						--actor.Health = actor.Health + 30;
						actor:AddHealth(30);
					else
						actor:AddHealth(100 - actor.Health - 1);
					end
					actor:FlashWhite(250);
				end
			end
		end
		self.HealTimer:Reset();
	end

	--
	-- Phase specific processing
	--

	-- Phase "NoFight"
	if self.CurrentFightPhase == self.FightPhase.NOFIGHT then
		self:AddObjectivePoint("Upload data", Vector(1798 , 2102), Activity.TEAM_1, GameActivity.ARROWDOWN);
		
		for player = 0, self.PlayerCount - 1 do
			if MovableMan:IsActor(self.AssignedBrains[player]) then
				if self.DataUploadZone:IsInside(self.AssignedBrains[player].Pos) then
					self.CurrentFightPhase = self.FightPhase.UPLOAD;
					
					if self.DummyDropshipsEnabled == false then
						self.DummyDropshipsEnabled = true;
						self.DropshipSpawnInterval = self.UploadSpawnInterval;
						-- self.SpawnTimer:Reset();
						for player = 0, self.PlayerCount - 1 do
							self:ResetMessageTimer(player);
							FrameMan:ClearScreenText(player);
							FrameMan:SetScreenText("DUMMIES!!! PROTECT BRAIN WHILE UPLOADING DATA", player, 1000, 10000, true);
						end
					end
	
					self.GenericTimer:Reset();
					break;
				end
			end
			
			if MovableMan:IsActor(self.AssignedBrains[player]) then
				if self.DummyAssaultTrigger:IsInside(self.AssignedBrains[player].Pos) then
					if self.DummyDropshipsEnabled == false then
						self.DummyDropshipsEnabled = true;
						self.DropshipSpawnInterval = self.UploadSpawnInterval;
						-- self.SpawnTimer:Reset();
						for player = 0, self.PlayerCount - 1 do
							self:ResetMessageTimer(player);
							FrameMan:ClearScreenText(player);
							FrameMan:SetScreenText("DUMMIES!!! DEFEND BRAIN WHILE UPLOADING DATA", player, 1000, 10000, true);
						end
					end
				end
			end
		end

	-- Phase "Upload"
	elseif self.CurrentFightPhase == self.FightPhase.UPLOAD then
		-- Show mission objective marks
		local braininside = false
		for player = 0, self.PlayerCount - 1 do
			if MovableMan:IsActor(self.AssignedBrains[player]) then
				if self.DataUploadZone:IsInside(self.AssignedBrains[player].Pos) then
					braininside = true;
					break;
				end
			end
		end
		
		if braininside then
			self:AddObjectivePoint("Uploading...", Vector(1798 , 2002), Activity.TEAM_1, GameActivity.ARROWUP);
		else
			self:AddObjectivePoint("Aborted !!!", Vector(1798 , 2102), Activity.TEAM_1, GameActivity.ARROWDOWN);
		end
		
		if self.GenericTimer:IsPastSimMS(self.UploadInterval) then
			for player = 0, self.PlayerCount - 1 do
				if MovableMan:IsActor(self.AssignedBrains[player]) then
					if self.DataUploadZone:IsInside(self.AssignedBrains[player].Pos) then
						if self.UploadedChunks <= 12 then
							self.SmallScreens[self.UploadedChunks]:EnableEmission(true);
							MovableMan:AddParticle(self.SmallScreens[self.UploadedChunks]);
						end
						self.UploadedChunks = self.UploadedChunks + 1;
						
						-- All chunks uploaded, phase complete
						if self.UploadedChunks == 14 then
							self.MainScreen:EnableEmission(true);
							MovableMan:AddParticle(self.MainScreen);
							self.CurrentFightPhase = self.FightPhase.HOLDPOSITION;
							self.DropshipSpawnInterval = self.HoldPositionSpawnInterval;
							self.GenericTimer:Reset();
						end
					end
				end
			end
			self.GenericTimer:Reset();
		end

	-- Phase Hold Position
	-- Show different objectives during this phase
	elseif self.CurrentFightPhase == self.FightPhase.HOLDPOSITION then
		if self.GenericTimer:IsPastSimMS(500) and self.HoldMessage1Shown == false then
			self.HoldMessage1Shown = true;
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("HOLD POSITION WHILE THE DATA IS BEING TRANSFERRED", player, 0, self.MessageDisplayTime, true);
			end			
		end

		if self.GenericTimer:IsPastSimMS(500 + self.NextMessageInterval) and self.HoldMessage2Shown == false then
			self.HoldMessage2Shown = true;
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("DUMMIES JAMMING OUR BROADBAND COMMUNICATIONS", player, 1000, self.MessageDisplayTime, true);
			end			
		end

		if self.GenericTimer:IsPastSimMS(500 + self.NextMessageInterval * 2) and self.HoldMessage3Shown == false then
			self.HoldMessage3Shown = true;
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("HOLD WHILE CENTRAL BRAIN FINDING SOLUTION", player, 0, self.MessageDisplayTime, true);
			end			
		end

		if self.GenericTimer:IsPastSimMS(500 + self.NextMessageInterval * 3) and self.HoldMessage4Shown == false then
			self.HoldMessage4Shown = true;
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("THERE ARE DUMMY COMMANDERS IN THE AREA", player, 1000, self.MessageDisplayTime, true);
			end			
		end

		if self.GenericTimer:IsPastSimMS(500 + self.NextMessageInterval * 4) and self.HoldMessage5Shown == false then
			self.HoldMessage5Shown = true;
			self.ReinforcementsEnabled = true;
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("KILL THEM AND RETRIEVE THREE DIFFERENT DUMMY CHIPS", player, 0, self.MessageDisplayTime, true);
			end			
		end

		if self.GenericTimer:IsPastSimMS(500 + self.NextMessageInterval * 5) and self.HoldMessage6Shown == false then
			self.HoldMessage6Shown = true;
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("COLLECT THREE DUFFERENT DUMMY CHIPS", player, 1000, self.MessageDisplayTime, true);
			end
		end

		if self.GenericTimer:IsPastSimMS(500 + self.NextMessageInterval * 6) then
			self.DropshipSpawnInterval = self.CommanderHuntSpawnInterval;
			self.CurrentFightPhase = self.FightPhase.COMMANDERHUNT;
			self.GenericTimer:Reset();
		end

	-- Phase "Commander Hunt" processing
	elseif self.CurrentFightPhase == self.FightPhase.COMMANDERHUNT then
		-- Check if we have dummy commander in the field
		if MovableMan:IsActor(self.DummyCommander) then
			self:AddObjectivePoint("Get Security Chip", Vector(self.DummyCommander.Pos.X , self.DummyCommander.Pos.Y - 27), Activity.TEAM_1, GameActivity.ARROWDOWN);
		else
			-- Check if we already have commander in dropship
			local commanderinship = false;
	        for actor in MovableMan.Actors do
				if actor:HasObject("Dummy Walking Controller") then
					commanderinship = true;
				end
			end
		
			-- No commander at all, spawn new commander and bodyguard
			if not commanderinship and MovableMan:GetMOIDCount() <= self.MOIDLimit then
				print "Spawn commander";
				-- Dummy commander is dead, send a new one on a dropship
				local ship = CreateACDropShip("Drop Ship","Dummy.rte");

				-- First add bodyguard dreadnought so this stupid can could not smash its commander
				local actor = CreateACrab("Dreadnought");
				actor.AIMode = Actor.AIMODE_SENTRY;
				actor.Team = Activity.TEAM_2;
				ship:AddInventoryItem(actor);

	
				-- Add commander unit
				self.DummyCommander = CreateAHuman("Dummy Walking Controller" , "Stratosphere.rte");
				self.DummyCommander:AddInventoryItem(CreateHDFirearm("Blaster MK2","Stratosphere.rte"));
				
				local rand = math.random();
				
				if rand < 0.33 then
					self.DummyCommander:AddInventoryItem(CreateHeldDevice("Dummy Chip 1","Stratosphere.rte"));
				elseif rand < 0.66 then
					self.DummyCommander:AddInventoryItem(CreateHeldDevice("Dummy Chip 2","Stratosphere.rte"));
				else
					self.DummyCommander:AddInventoryItem(CreateHeldDevice("Dummy Chip 3","Stratosphere.rte"));
				end
				self.DummyCommander.AIMode = Actor.AIMODE_SENTRY;
				self.DummyCommander.Team = Activity.TEAM_2;
				ship:AddInventoryItem(self.DummyCommander);
	
				rand = math.random();
				if rand < 0.14 then
					ship.Pos = Vector(self.CommanderLZLeft:GetRandomPoint().X, 0);
				elseif rand < 0.28 then
					ship.Pos = Vector(self.CommanderLZUp:GetRandomPoint().X, 0);
				elseif rand < 0.42 then
					ship.Pos = Vector(self.CommanderLZLeftUp:GetRandomPoint().X, 0);
				elseif rand < 0.56 then
					ship.Pos = Vector(self.Level1LeftLZ:GetRandomPoint().X, 0);
				elseif rand < 0.71 then
					ship.Pos = Vector(self.Level1RightLZ:GetRandomPoint().X, 0);
				elseif rand < 0.85 then
					ship.Pos = Vector(self.Level2LeftLZ:GetRandomPoint().X, 0);
				else
					ship.Pos = Vector(self.Level2RightLZ:GetRandomPoint().X, 0);
				end
				
				ship.Team = Activity.TEAM_2;
				ship:SetControllerMode(Controller.CIM_AI, -1);
				MovableMan:AddActor(ship);
			end
		end
		
		-- Check if we have dummy keys
		for player = 0, self.PlayerCount - 1 do
			if MovableMan:IsActor(self.AssignedBrains[player]) then
				if self.AssignedBrains[player]:HasObject("Dummy Chip 1") then
					if self.Chip1Collected == false then
						self.Chip1Collected = true;
						self.ReinforcementRobotPending = true;
					end
				end
			end

			if MovableMan:IsActor(self.AssignedBrains[player]) then
				if self.AssignedBrains[player]:HasObject("Dummy Chip 2") then
					if self.Chip2Collected == false then
						self.Chip2Collected = true;
						self.ReinforcementRobotPending = true;
					end
				end
			end

			if MovableMan:IsActor(self.AssignedBrains[player]) then
				if self.AssignedBrains[player]:HasObject("Dummy Chip 3") then
					if self.Chip3Collected == false then
						self.Chip3Collected = true;
						self.ReinforcementRobotPending = true;
					end
				end
			end
		end
		
		-- Show chip collection progress
		if self.GenericTimer:IsPastSimMS(15000) then
			local collectedchips = 0;

			if self.Chip1Collected then 
				collectedchips = collectedchips + 1
			end
			if self.Chip2Collected then 
				collectedchips = collectedchips + 1
			end
			if self.Chip3Collected then 
				collectedchips = collectedchips + 1;
			end

			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				if collectedchips == 0 then
					FrameMan:SetScreenText("NO DUMMY SECURITY CHIPS COLLECTED", player, 0, 3000, true);
				elseif collectedchips == 1 then
					FrameMan:SetScreenText("ONE DUMMY SECURITY CHIP COLLECTED", player, 0, 3000, true);
				elseif collectedchips == 2 then
					FrameMan:SetScreenText("TWO DUMMY SECURITY CHIPS COLLECTED", player, 0, 3000, true);
				else
					FrameMan:SetScreenText("THREE DUMMY SECURITY CHIPS COLLECTED", player, 0, 3000, true);
				end
			end
		
			self.GenericTimer:Reset();
		end
		
		-- Check if we already have all chips needed to progress to next phase
		if self.Chip1Collected and self.Chip2Collected and self.Chip3Collected then
			self.DropshipSpawnInterval = self.ChipActivationSpawnInterval;
			self.CurrentFightPhase = self.FightPhase.CHIPACTIVATION;
			self.GenericTimer:Reset();
		end

	-- Phase "Chip activation"
	elseif self.CurrentFightPhase == self.FightPhase.CHIPACTIVATION then
		-- Show mission objective marks
		
		if self.KeysActivated == false then
			local braininside = false
			for player = 0, self.PlayerCount - 1 do
				if MovableMan:IsActor(self.AssignedBrains[player]) then 
					if self.AuxilaryTerminal:IsInside(self.AssignedBrains[player].Pos) then
						print("Brain inside");
						braininside = true;
						break;
					end
				else
					print ("Not an actor");
				end
			end
			
			if braininside then 
				self.KeysActivated = true;
				self.AuxScreen:EnableEmission(true);
				MovableMan:AddParticle(self.AuxScreen);
			end
			-- Reset geneic timer so it could not trigger winning conditions before chips taken to terminal
			self.GenericTimer:Reset();
		end
		
		if self.KeysActivated then
			self:AddObjectivePoint("Cracking Dummy Security Codes...", Vector(1680 , 1620), Activity.TEAM_1, GameActivity.ARROWUP);
		else
			self:AddObjectivePoint("Auxilary Terminal", Vector(1680 , 1660), Activity.TEAM_1, GameActivity.ARROWDOWN);
		end
		
		if self.CrackMessage1Shown == false then
			self.CrackMessage1Shown = true;
			self.ReinforcementsEnabled = true;
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("ALL CHIPS COLLECTED. GET YOUR BRAIN TO THE AUXILARY TERMINAL", player, 0, self.MessageDisplayTime, true);
			end			
		end

		if self.GenericTimer:IsPastSimMS(self.CrackInterval / 4) and self.CrackMessage2Shown == false then
			self.CrackMessage2Shown = true;
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("CRACKING... 25% COMPLETE", player, 1000, 4000, true);
			end			
		end

		if self.GenericTimer:IsPastSimMS((self.CrackInterval / 4) * 2) and self.CrackMessage3Shown == false then
			self.CrackMessage3Shown = true;
			self.ReinforcementRobotPending = true;
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("CRACKING... 50% COMPLETE", player, 1000, 4000, true);
			end			
		end

		if self.GenericTimer:IsPastSimMS((self.CrackInterval / 4) * 3) and self.CrackMessage4Shown == false then
			self.CrackMessage4Shown = true;
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("CRACKING... 75% COMPLETE", player, 1000, 4000, true);
			end			
		end
		
		if self.GenericTimer:IsPastSimMS(self.CrackInterval) and self.KeysActivated and self.MissionComplete == false then
			for player = 0, self.PlayerCount - 1 do
				self:ResetMessageTimer(player);
				FrameMan:ClearScreenText(player);
				FrameMan:SetScreenText("LOCAL DUMMY SECURITY CONTROL CHANNEL HACKED. SELF-DESTRUCT INITIATED", player, 1000, 10000, true);
			end

			self.DummyDropshipsEnabled = false;
			self.ReinforcementsEnabled = false;
			self.MissionComplete = true;
			
			-- Team 1 wins!
			self.WinnerTeam = Activity.TEAM_1;
			ActivityMan:EndActivity();
			-- Tell the script to stop running for brains as the game has ended.
			
			for player2 = 0, self.PlayerCount - 1 do
				self.braindead[player2] = true;
			end
			-- self.GenericTimer:Reset();
		end

		-- Slowly gib remaining dummies every 500 ms to simulate self-distruct
		if self.GenericTimer:IsPastSimMS(500) and self.KeysActivated and self.MissionComplete == true then
			for actor in MovableMan.Actors do
				if actor.Team == Activity.TEAM_2 then 
					actor:GibThis();
					break;
				end
			end
			self.GenericTimer:Reset();
		end

	end	
	
	self:YSortObjectivePoints();
end
